﻿using HarmonyLib;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using UnityEngine;

public class RecipesAndMore : Mod
{
    private const string HARMONY_ID = "BalanceOverhaul";
    private Harmony harmonyInstance;

    private int _currentUses;
    private int _num = Random.Range(1, 4);

    public void Start()
    {

        ComponentManager<RecipesAndMore>.Value = this;

        harmonyInstance = new Harmony(HARMONY_ID);
        harmonyInstance.PatchAll(Assembly.GetExecutingAssembly());

        //Creates the Scrap Recipe
        Item_Base[] multipleItems = new Item_Base[] { ItemManager.GetItemByName("MetalIngot"), ItemManager.GetItemByName("Hinge"), ItemManager.GetItemByName("Bolt") };
        CreateRecipe0(ItemManager.GetItemByName("Scrap"), 5, new CostMultiple(multipleItems, 1));

        //creates the MetalOre Recipe
        CreateRecipe1(ItemManager.GetItemByName("MetalOre"), 1, new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Scrap") }, 5));

        //changes the MetalDetector Recipe part 1
        CreateRecipe2(ItemManager.GetItemByName("MetalDetector"), 1);
        allowItems2("Scrap", "Nail");
        // end MD part 1

        //creates the TitaniumIngot Recipe part 1
        CreateRecipe3(ItemManager.GetItemByName("TitaniumIngot"), 1);
        allowItems3("Scrap", "Nail");
        // end TI part 1

        //changes the HealingSalve Recipe part 1
        CreateRecipe4(ItemManager.GetItemByName("HealingSalve"), 1);
        allowItems4("Raw_Herring", "Raw_Mackerel", "Raw_Pomfret");
        //end HS part 1

        //add recipe for Leather part 1
        CreateRecipe5(ItemManager.GetItemByName("Leather"), 2);
        allowItems5("Head_Boar", "Head_Screecher", "Head_Shark");
        //end L part 1

        //creates the Explosive Goo Recipe part 1
        CreateRecipe6(ItemManager.GetItemByName("ExplosiveGoo"), 2);
        allowItems6("Dirt", "HoneyComb");
        //end EG part 1

        //changes Augmented Items Recipe Hook_Titanium part 1
        if (ItemManager.GetItemByName("Hook_Titanium") == true)
        {
            CreateRecipeHT1(ItemManager.GetItemByName("Hook_Titanium"), 1);
            allowItemsHT1();
        }
        //end AIHT1 part 1

        //changes Augmented Items Recipe Titanium_Shovel part 1
        if (ItemManager.GetItemByName("Titanium_Shovel") == true)
        {
            CreateRecipeTS2(ItemManager.GetItemByName("Titanium_Shovel"), 1);
            allowItemsTS2();
        }
        //end AITS2 part 1

        //changes Augmented Items Recipe Titanium_Arrow part 1
        if (ItemManager.GetItemByName("Titanium_Arrow") == true)
        {
            CreateRecipeTA3(ItemManager.GetItemByName("Titanium_Arrow"), 1);
            allowItemsTA3();
        }
        //end AITA3 part 1

        //changes Augmented Items Recipe Placeable_Storage_MediumTitanium part 1
        if (ItemManager.GetItemByName("Placeable_Storage_MediumTitanium") == true)
        {
            CreateRecipePSM4(ItemManager.GetItemByName("Placeable_Storage_MediumTitanium"), 1); // der hier geht nicht
            allowItemsPSM4();
        }
        //end AIPSM4 part 1

        //changes Augmented Items Recipe Placeable_Motorwheel_Titanium part 1
        if (ItemManager.GetItemByName("Placeable_Motorwheel_Titanium") == true)
        {
            CreateRecipePMT5(ItemManager.GetItemByName("Placeable_Motorwheel_Titanium"), 1); // der hier geht nicht
            allowItemsPMT5();
        }
        //end AIPMT5 part 1

        //changes Augmented Items Recipe Placeable_CookingStand_SmelterArc part 1
        if (ItemManager.GetItemByName("Placeable_CookingStand_SmelterArc") == true)
        {
            CreateRecipePCS6(ItemManager.GetItemByName("Placeable_CookingStand_SmelterArc"), 1); // der hier geht merkwürdigerweise
            allowItemsPCS6();
        }
        //end AIPCS6 part 1

        //changes Augmented Items Recipe Titanium_Axe part 1
        if (ItemManager.GetItemByName("Titanium_Axe") == true)
        {
            CreateRecipeTA7(ItemManager.GetItemByName("Titanium_Axe"), 1);
            allowItemsTA7();
        }
        //end AITS7 part 1

        //changes the SharkDinner Recipe part 1
        CreateRecipe7(ItemManager.GetItemByName("ClayPlate_SharkDinner"), 2);
        allowItems7("Raw_Pomfret");
        //end SD part 1

        Debug.Log("Mod RecipesAndMore has been loaded!");
    }

    /// <param name="pResultItem0">Item resulting from the crafting.</param>
    /// <param name="pAmount0">Crafting-Output Amount.</param>
    /// <param name="pCosts0">Crafting costs.</param>
    public static void CreateRecipe0(Item_Base pResultItem0, int pAmount0, params CostMultiple[] pCosts0)
    {
        Traverse.Create(pResultItem0.settings_recipe).Field("newCostToCraft").SetValue(pCosts0);
        Traverse.Create(pResultItem0.settings_recipe).Field("learned").SetValue(false);
        Traverse.Create(pResultItem0.settings_recipe).Field("learnedFromBeginning").SetValue(false);
        Traverse.Create(pResultItem0.settings_recipe).Field("craftingCategory").SetValue(CraftingCategory.Resources);
        Traverse.Create(pResultItem0.settings_recipe).Field("amountToCraft").SetValue(pAmount0);
    }

    /// <summary>
    /// Function creating a new recipe setting with new recipe.
    /// </summary>
    /// <param name="pResultItem1">Item resulting from the crafting.</param>
    /// <param name="pAmount1">Crafting-Output Amount.</param>
    /// <param name="pCosts1">Crafting costs.</param>
    public static void CreateRecipe1(Item_Base pResultItem1, int pAmount1, params CostMultiple[] pCosts1)
    {
        Traverse.Create(pResultItem1.settings_recipe).Field("newCostToCraft").SetValue(pCosts1);
        Traverse.Create(pResultItem1.settings_recipe).Field("learned").SetValue(false);
        Traverse.Create(pResultItem1.settings_recipe).Field("learnedFromBeginning").SetValue(false);
        Traverse.Create(pResultItem1.settings_recipe).Field("craftingCategory").SetValue(CraftingCategory.Resources);
        Traverse.Create(pResultItem1.settings_recipe).Field("amountToCraft").SetValue(pAmount1);
        // changes maxUses for MilkBucket
        //AccessTools.Field(typeof(Item_Base), "maxUses").SetValue(ItemManager.GetItemByName("Bucket_Milk"), 2);
        // changes stacksize of Milkbucket and other things
        Traverse.Create(ItemManager.GetItemByName("Bucket_Milk").settings_Inventory).Field("stackSize").SetValue(20);
        Traverse.Create(ItemManager.GetItemByName("Claybowl_CoconutChicken").settings_Inventory).Field("stackSize").SetValue(20);
        Traverse.Create(ItemManager.GetItemByName("Claybowl_FishStew").settings_Inventory).Field("stackSize").SetValue(20);
        Traverse.Create(ItemManager.GetItemByName("Claybowl_HeadBroth").settings_Inventory).Field("stackSize").SetValue(20);
        Traverse.Create(ItemManager.GetItemByName("Claybowl_Leftover").settings_Inventory).Field("stackSize").SetValue(20);
        Traverse.Create(ItemManager.GetItemByName("Claybowl_SimpleFishStew").settings_Inventory).Field("stackSize").SetValue(20);
        Traverse.Create(ItemManager.GetItemByName("Claybowl_RootVegetableSoup").settings_Inventory).Field("stackSize").SetValue(20);
        Traverse.Create(ItemManager.GetItemByName("ClayPlate_CatfishDeluxe").settings_Inventory).Field("stackSize").SetValue(20);
        Traverse.Create(ItemManager.GetItemByName("ClayPlate_DrumstickWithJam").settings_Inventory).Field("stackSize").SetValue(20);
        Traverse.Create(ItemManager.GetItemByName("ClayPlate_FruitCompot").settings_Inventory).Field("stackSize").SetValue(20);
        Traverse.Create(ItemManager.GetItemByName("ClayPlate_MushroomOmelette").settings_Inventory).Field("stackSize").SetValue(20);
        Traverse.Create(ItemManager.GetItemByName("ClayPlate_SalmonSalad").settings_Inventory).Field("stackSize").SetValue(20);
        Traverse.Create(ItemManager.GetItemByName("Placeable_GiantClam").settings_Inventory).Field("stackSize").SetValue(20);

        Traverse.Create(ItemManager.GetItemByName("ClayPlate_SharkDinner").settings_consumeable).Field("bonusHungerYield").SetValue(100);
        Traverse.Create(ItemManager.GetItemByName("ClayPlate_SharkDinner").settings_Inventory).Field("description").SetValue("tastes like chicken...");
        Traverse.Create(ItemManager.GetItemByName("MetalDetector").settings_Inventory).Field("description").SetValue("what a sweet little tool I got here...");
    }

    //changes the MetalDetector Recipe part 2
    private void allowItems2(params string[] validItemNames2)
    {
        var plasticItem = ItemManager.GetItemByName("Plastic");
        var plasticIngredient = new CostMultiple(new Item_Base[] { plasticItem }, 12);

        var scrapItem = ItemManager.GetItemByName("Scrap");
        var scrapIngredient = new CostMultiple(new Item_Base[] { scrapItem }, 6);

        var batteryItem = ItemManager.GetItemByName("Battery");
        var batteryIngredient = new CostMultiple(new Item_Base[] { batteryItem }, 2);

        var ropeItem = ItemManager.GetItemByName("Rope");
        var ropeIngredient = new CostMultiple(new Item_Base[] { ropeItem }, 3);

        //var validItems2 = validItemNames2.Select(name => ItemManager.GetItemByName(name)).ToArray();
        //var validIngredients2 = new CostMultiple(validItems2, 2);

        var metdetec = ItemManager.GetItemByName("MetalDetector");
        metdetec.settings_recipe.NewCost = new CostMultiple[] { plasticIngredient, scrapIngredient, batteryIngredient, ropeIngredient };
    }
    /// <param name="pResultItem2">Item resulting from the crafting.</param>
    public static void CreateRecipe2(Item_Base pResultItem2, int pAmount2)
    {
        AccessTools.Field(typeof(Item_Base), "maxUses").SetValue(ItemManager.GetItemByName("MetalDetector"), 200);
        Traverse.Create(pResultItem2.settings_recipe).Field("craftingCategory").SetValue(CraftingCategory.Tools);
        Traverse.Create(pResultItem2.settings_recipe).Field("amountToCraft").SetValue(pAmount2);
        Traverse.Create(pResultItem2.settings_recipe).Field("learnedFromBeginning").SetValue(true);
    }
    // end MD part 2

    //creates the TitaniumIngot Recipe part 2
    private void allowItems3(params string[] validItemNames3)
    {
        var metaloreItem = ItemManager.GetItemByName("MetalOre");
        var metaloreIngredient = new CostMultiple(new Item_Base[] { metaloreItem }, 4);

        var copperItem = ItemManager.GetItemByName("CopperOre");
        var copperIngredient = new CostMultiple(new Item_Base[] { copperItem }, 8);

        var brickdryItem = ItemManager.GetItemByName("Brick_Dry");
        var brickdryIngredient = new CostMultiple(new Item_Base[] { brickdryItem }, 2);

        var dirtItem = ItemManager.GetItemByName("Dirt");
        var dirtIngredient = new CostMultiple(new Item_Base[] { dirtItem }, 3);

        var vinegooItem = ItemManager.GetItemByName("VineGoo");
        var vinegooIngredient = new CostMultiple(new Item_Base[] { vinegooItem }, 2);

        var pcfoItem = ItemManager.GetItemByName("Placeable_CookingStand_Food_One");
        var pcfoIngredient = new CostMultiple(new Item_Base[] { pcfoItem }, 1);

        var jarItem = ItemManager.GetItemByName("HoneyComb");
        var jarIngredient = new CostMultiple(new Item_Base[] { jarItem }, 1);

        //var validItems3 = validItemNames3.Select(name => ItemManager.GetItemByName(name)).ToArray();
        //var validIngredients3 = new CostMultiple(validItems3, 4);

        var titaning = ItemManager.GetItemByName("TitaniumIngot");
        titaning.settings_recipe.NewCost = new CostMultiple[] { metaloreIngredient, copperIngredient, brickdryIngredient, dirtIngredient, vinegooIngredient, pcfoIngredient, jarIngredient };
    }
    /// <param name="pResultItem3">Item resulting from the crafting.</param>
    public static void CreateRecipe3(Item_Base pResultItem3, int pAmount3)
    {
        Traverse.Create(pResultItem3.settings_recipe).Field("craftingCategory").SetValue(CraftingCategory.Resources);
        Traverse.Create(pResultItem3.settings_recipe).Field("amountToCraft").SetValue(pAmount3);
        Traverse.Create(pResultItem3.settings_recipe).Field("learnedFromBeginning").SetValue(false);
    }
    // end TI part 2

    //changes the HealingSalve Recipe part 2
    private void allowItems4(params string[] validItemNames4)
    {
        var seavineItem = ItemManager.GetItemByName("SeaVine");
        var seavineIngredient = new CostMultiple(new Item_Base[] { seavineItem }, 2);

        var validItems4 = validItemNames4.Select(name => ItemManager.GetItemByName(name)).ToArray();
        var validIngredients4 = new CostMultiple(validItems4, 2);

        var healsalv = ItemManager.GetItemByName("HealingSalve");
        healsalv.settings_recipe.NewCost = new CostMultiple[] { seavineIngredient, validIngredients4 };
    }
    /// <param name="pResultItem3">Item resulting from the crafting.</param>
    public static void CreateRecipe4(Item_Base pResultItem4, int pAmount4)
    {
        Traverse.Create(pResultItem4.settings_recipe).Field("craftingCategory").SetValue(CraftingCategory.FoodWater);
        Traverse.Create(pResultItem4.settings_recipe).Field("amountToCraft").SetValue(pAmount4);
        Traverse.Create(pResultItem4.settings_recipe).Field("learnedFromBeginning").SetValue(true);
    }
    // end HS part 2

    // add Recipe for Leather part 2
    private void allowItems5(params string[] validItemNames5)
    {
        var copingItem = ItemManager.GetItemByName("CopperIngot");
        var copingIngredient = new CostMultiple(new Item_Base[] { copingItem }, 4);

        var stoneItem = ItemManager.GetItemByName("Stone");
        var stoneIngredient = new CostMultiple(new Item_Base[] { stoneItem }, 8);

        var pcspoItem = ItemManager.GetItemByName("Placeable_CookingStand_Purifier_One");
        var pcspoIngredient = new CostMultiple(new Item_Base[] { pcspoItem }, 1);

        var flowredItem = ItemManager.GetItemByName("Flower_Red");
        var flowredIngredient = new CostMultiple(new Item_Base[] { flowredItem }, 4);

        var flowblackItem = ItemManager.GetItemByName("Flower_Black");
        var flowblackIngredient = new CostMultiple(new Item_Base[] { flowblackItem }, 4);

        var validItems5 = validItemNames5.Select(name => ItemManager.GetItemByName(name)).ToArray();
        var validIngredients5 = new CostMultiple(validItems5, 1);

        var lether5 = ItemManager.GetItemByName("Leather");
        lether5.settings_recipe.NewCost = new CostMultiple[] { copingIngredient, stoneIngredient, pcspoIngredient, flowredIngredient, flowblackIngredient, validIngredients5 };
    }
    /// <param name="pResultItem5">Item resulting from the crafting.</param>
    public static void CreateRecipe5(Item_Base pResultItem5, int pAmount5)
    {
        //AccessTools.Field(typeof(Item_Base), "maxUses").SetValue(ItemManager.GetItemByName("MetalDetector"), 200);
        Traverse.Create(pResultItem5.settings_recipe).Field("craftingCategory").SetValue(CraftingCategory.Resources);
        Traverse.Create(pResultItem5.settings_recipe).Field("amountToCraft").SetValue(pAmount5);
        Traverse.Create(pResultItem5.settings_recipe).Field("learnedFromBeginning").SetValue(false);
    }
    // end L part 2

    // add Recipe for Explosive Goo part 2
    private void allowItems6(params string[] validItemNames6)
    {
        var sandItem = ItemManager.GetItemByName("Sand");
        var sandIngredient = new CostMultiple(new Item_Base[] { sandItem }, 4);

        var clayItem = ItemManager.GetItemByName("Clay");
        var clayIngredient = new CostMultiple(new Item_Base[] { clayItem }, 4);

        var gooItem = ItemManager.GetItemByName("VineGoo");
        var gooIngredient = new CostMultiple(new Item_Base[] { gooItem }, 3);

        var dyeItem = ItemManager.GetItemByName("Flower_Blue");
        var dyeIngredient = new CostMultiple(new Item_Base[] { dyeItem }, 4);

        var validItems6 = validItemNames6.Select(name => ItemManager.GetItemByName(name)).ToArray();
        var validIngredients6 = new CostMultiple(validItems6, 2);

        var goo = ItemManager.GetItemByName("ExplosiveGoo");
        goo.settings_recipe.NewCost = new CostMultiple[] { sandIngredient, clayIngredient, gooIngredient, dyeIngredient, validIngredients6 };
    }

    /// <param name="pResultItem6">Item resulting from the crafting.</param>
    public static void CreateRecipe6(Item_Base pResultItem6, int pAmount6)
    {
        Traverse.Create(pResultItem6.settings_recipe).Field("craftingCategory").SetValue(CraftingCategory.Resources);
        Traverse.Create(pResultItem6.settings_recipe).Field("amountToCraft").SetValue(pAmount6);
    }
    //end EG part 2

    private void allowItemsHT1(params string[] validItemNamesHT1)
    {
        var titIngotHT1Item = ItemManager.GetItemByName("TitaniumIngot");
        var titIngotHT1Ingredient = new CostMultiple(new Item_Base[] { titIngotHT1Item }, 6);

        var boltHT1Item = ItemManager.GetItemByName("Bolt");
        var boltHT1Ingredient = new CostMultiple(new Item_Base[] { boltHT1Item }, 2);

        var scrapHT1Item = ItemManager.GetItemByName("Scrap");
        var scrapHT1Ingredient = new CostMultiple(new Item_Base[] { scrapHT1Item }, 10);

        var ropeHT1Item = ItemManager.GetItemByName("Rope");
        var ropeHT1Ingredient = new CostMultiple(new Item_Base[] { ropeHT1Item }, 4);

        var honeyHT1Item = ItemManager.GetItemByName("HoneyComb");
        var honeyHT1Ingredient = new CostMultiple(new Item_Base[] { honeyHT1Item }, 12);

        var hookTitaniumHT1 = ItemManager.GetItemByName("Hook_Titanium");
        hookTitaniumHT1.settings_recipe.NewCost = new CostMultiple[] { titIngotHT1Ingredient, boltHT1Ingredient, scrapHT1Ingredient, ropeHT1Ingredient, honeyHT1Ingredient };
    }

    public static void CreateRecipeHT1(Item_Base pResultItemHT1, int pAmountHT1)
    {
    }

    private void allowItemsTS2(params string[] validItemNamesTS2)
    {
        var titIngotTS2Item = ItemManager.GetItemByName("TitaniumIngot");
        var titIngotTS2Ingredient = new CostMultiple(new Item_Base[] { titIngotTS2Item }, 4);

        var boltTS2Item = ItemManager.GetItemByName("Bolt");
        var boltTS2Ingredient = new CostMultiple(new Item_Base[] { boltTS2Item }, 4);

        var scrapTS2Item = ItemManager.GetItemByName("Scrap");
        var scrapTS2Ingredient = new CostMultiple(new Item_Base[] { scrapTS2Item }, 15);

        var plankTS2Item = ItemManager.GetItemByName("Plank");
        var plankTS2Ingredient = new CostMultiple(new Item_Base[] { plankTS2Item }, 20);

        var honeyTS2Item = ItemManager.GetItemByName("HoneyComb");
        var honeyTS2Ingredient = new CostMultiple(new Item_Base[] { honeyTS2Item }, 10);

        var titaniumShovelTS2 = ItemManager.GetItemByName("Titanium_Shovel");
        titaniumShovelTS2.settings_recipe.NewCost = new CostMultiple[] { titIngotTS2Ingredient, boltTS2Ingredient, scrapTS2Ingredient, plankTS2Ingredient, honeyTS2Ingredient };
    }

    public static void CreateRecipeTS2(Item_Base pResultItemHT1, int pAmountTS2)
    {
    }

    private void allowItemsTA3(params string[] validItemNamesTA3)
    {
        var titIngotTA3Item = ItemManager.GetItemByName("TitaniumIngot");
        var titIngotTA3Ingredient = new CostMultiple(new Item_Base[] { titIngotTA3Item }, 1);

        var plankTA3Item = ItemManager.GetItemByName("Plank");
        var plankTA3Ingredient = new CostMultiple(new Item_Base[] { plankTA3Item }, 3);

        var featherTA3Item = ItemManager.GetItemByName("Feather");
        var featherTA3Ingredient = new CostMultiple(new Item_Base[] { featherTA3Item }, 6);

        var honeyTA3Item = ItemManager.GetItemByName("HoneyComb");
        var honeyTA3Ingredient = new CostMultiple(new Item_Base[] { honeyTA3Item }, 3);

        var titaniumArrowTA3 = ItemManager.GetItemByName("Titanium_Arrow");
        titaniumArrowTA3.settings_recipe.NewCost = new CostMultiple[] { titIngotTA3Ingredient, plankTA3Ingredient, featherTA3Ingredient, honeyTA3Ingredient };
    }

    public static void CreateRecipeTA3(Item_Base pResultItemTA3, int pAmountTA3)
    {
    }

    private void allowItemsPSM4(params string[] validItemNamesPSM4)
    {
        var storageLargePSM4Item = ItemManager.GetItemByName("Placeable_Storage_Large");
        var storageLargePSM4Ingredient = new CostMultiple(new Item_Base[] { storageLargePSM4Item }, 1);

        var copIngotPSM4Item = ItemManager.GetItemByName("CopperIngot");
        var copIngotPSM4Ingredient = new CostMultiple(new Item_Base[] { copIngotPSM4Item }, 5);

        var metIngotPSM4Item = ItemManager.GetItemByName("MetalIngot");
        var metIngotPSM4Ingredient = new CostMultiple(new Item_Base[] { metIngotPSM4Item }, 5);

        var plasticPSM4Item = ItemManager.GetItemByName("Plastic");
        var plasticPSM4Ingredient = new CostMultiple(new Item_Base[] { plasticPSM4Item }, 30);

        var nailPSM4Item = ItemManager.GetItemByName("Nail");
        var nailPSM4Ingredient = new CostMultiple(new Item_Base[] { nailPSM4Item }, 40);

        var titIngotPSM4Item = ItemManager.GetItemByName("TitaniumIngot");
        var titIngotPSM4Ingredient = new CostMultiple(new Item_Base[] { titIngotPSM4Item }, 3);

        var storageTitaniumPSM4 = ItemManager.GetItemByName("Placeable_Storage_MediumTitanium");
        storageTitaniumPSM4.settings_recipe.NewCost = new CostMultiple[] { storageLargePSM4Ingredient, copIngotPSM4Ingredient, metIngotPSM4Ingredient, nailPSM4Ingredient, titIngotPSM4Ingredient };
    }

    public static void CreateRecipePSM4(Item_Base pResultItemPSM4, int pAmountPSM4)
    {
    }

    private void allowItemsPMT5(params string[] validItemNamesPMT5)
    {
        var motorWheelPMT5Item = ItemManager.GetItemByName("Placeable_MotorWheel");
        var motorWheelPMT5Ingredient = new CostMultiple(new Item_Base[] { motorWheelPMT5Item }, 1);

        var titIngotPMT5Item = ItemManager.GetItemByName("TitaniumIngot");
        var titIngotPMT5Ingredient = new CostMultiple(new Item_Base[] { titIngotPMT5Item }, 19);

        var exploPowderPMT5Item = ItemManager.GetItemByName("ExplosivePowder");
        var exploPowderPMT5Ingredient = new CostMultiple(new Item_Base[] { exploPowderPMT5Item }, 30);

        var metIngotPMT5Item = ItemManager.GetItemByName("MetalIngot");
        var metIngotPMT5Ingredient = new CostMultiple(new Item_Base[] { metIngotPMT5Item }, 20);

        var copIngotPMT5Item = ItemManager.GetItemByName("CopperIngot");
        var copIngotPMT5Ingredient = new CostMultiple(new Item_Base[] { copIngotPMT5Item }, 20);

        var bioFuelPMT5Item = ItemManager.GetItemByName("BioFuel");
        var bioFuelPMT5Ingredient = new CostMultiple(new Item_Base[] { bioFuelPMT5Item }, 10);

        var honeyPMT5Item = ItemManager.GetItemByName("HoneyComb");
        var honeyPMT5Ingredient = new CostMultiple(new Item_Base[] { honeyPMT5Item }, 24);

        var motorwheelTitaniumPMT5 = ItemManager.GetItemByName("Placeable_Motorwheel_Titanium");
        motorwheelTitaniumPMT5.settings_recipe.NewCost = new CostMultiple[] { motorWheelPMT5Ingredient, titIngotPMT5Ingredient, exploPowderPMT5Ingredient, metIngotPMT5Ingredient, copIngotPMT5Ingredient, bioFuelPMT5Ingredient, honeyPMT5Ingredient };
    }

    public static void CreateRecipePMT5(Item_Base pResultItemPMT5, int pAmountPMT5)
    {
    }

    private void allowItemsPCS6(params string[] validItemNamesPCS6)
    {
        var titIngotPCS6Item = ItemManager.GetItemByName("TitaniumIngot");
        var titIngotPCS6Ingredient = new CostMultiple(new Item_Base[] { titIngotPCS6Item }, 5);

        var exploPowderPCS6Item = ItemManager.GetItemByName("ExplosivePowder");
        var exploPowderPCS6Ingredient = new CostMultiple(new Item_Base[] { exploPowderPCS6Item }, 5);

        var batteryPCS6Item = ItemManager.GetItemByName("Battery");
        var batteryPCS6Ingredient = new CostMultiple(new Item_Base[] { batteryPCS6Item }, 3);

        var circBoardPCS6Item = ItemManager.GetItemByName("CircuitBoard");
        var circBoardPCS6Ingredient = new CostMultiple(new Item_Base[] { circBoardPCS6Item }, 6);

        var brickDryPCS6Item = ItemManager.GetItemByName("Brick_Dry");
        var brickDryPCS6Ingredient = new CostMultiple(new Item_Base[] { brickDryPCS6Item }, 10);

        var honeyPCS6Item = ItemManager.GetItemByName("HoneyComb");
        var honeyPCS6Ingredient = new CostMultiple(new Item_Base[] { honeyPCS6Item }, 10);

        var smelterArcPCS6 = ItemManager.GetItemByName("Placeable_CookingStand_SmelterArc");
        smelterArcPCS6.settings_recipe.NewCost = new CostMultiple[] { titIngotPCS6Ingredient, exploPowderPCS6Ingredient, batteryPCS6Ingredient, circBoardPCS6Ingredient, brickDryPCS6Ingredient, honeyPCS6Ingredient };
    }

    public static void CreateRecipePCS6(Item_Base pResultItemPCS6, int pAmountPCS6)
    {
    }

    private void allowItemsTA7(params string[] validItemNamesTA7)
    {
        var titIngotTA7Item = ItemManager.GetItemByName("TitaniumIngot");
        var titIngotTA7Ingredient = new CostMultiple(new Item_Base[] { titIngotTA7Item }, 4);

        var boltTA7Item = ItemManager.GetItemByName("Bolt");
        var boltTA7Ingredient = new CostMultiple(new Item_Base[] { boltTA7Item }, 2);

        var scrapTA7Item = ItemManager.GetItemByName("Scrap");
        var scrapTA7Ingredient = new CostMultiple(new Item_Base[] { scrapTA7Item }, 10);

        var plankTA7Item = ItemManager.GetItemByName("Plank");
        var plankTA7Ingredient = new CostMultiple(new Item_Base[] { plankTA7Item }, 10);

        var vineGooTA7Item = ItemManager.GetItemByName("VineGoo");
        var vineGooTA7Ingredient = new CostMultiple(new Item_Base[] { vineGooTA7Item }, 2);

        var honeyTA7Item = ItemManager.GetItemByName("HoneyComb");
        var honeyTA7Ingredient = new CostMultiple(new Item_Base[] { honeyTA7Item }, 4);

        var titaniumAxeTA7 = ItemManager.GetItemByName("Titanium_Axe");
        titaniumAxeTA7.settings_recipe.NewCost = new CostMultiple[] { titIngotTA7Ingredient, boltTA7Ingredient, scrapTA7Ingredient, plankTA7Ingredient, vineGooTA7Ingredient, honeyTA7Ingredient };
    }

    public static void CreateRecipeTA7(Item_Base pResultItemTA7, int pAmountTA7)
    {
    }

    // add Recipe for SharkDinner part 2
    private void allowItems7(params string[] validItemNames7)
    {
        var pcs7Item = ItemManager.GetItemByName("Placeable_CookingStand_Food_One");
        var pcs7Ingredient = new CostMultiple(new Item_Base[] { pcs7Item }, 1);

        var claybowl7Item = ItemManager.GetItemByName("Claybowl_Empty");
        var claybowl7Ingredient = new CostMultiple(new Item_Base[] { claybowl7Item }, 2);

        var egg7Item = ItemManager.GetItemByName("Placeable_GiantClam");
        var egg7Ingredient = new CostMultiple(new Item_Base[] { egg7Item }, 2);

        var honey7Item = ItemManager.GetItemByName("Jar_Honey");
        var honey7Ingredient = new CostMultiple(new Item_Base[] { honey7Item }, 1);

        var mushroom7Item = ItemManager.GetItemByName("CaveMushroom");
        var mushroom7Ingredient = new CostMultiple(new Item_Base[] { mushroom7Item }, 2);

        var chicken7Item = ItemManager.GetItemByName("Raw_Drumstick");
        var chicken7Ingredient = new CostMultiple(new Item_Base[] { chicken7Item }, 3);

        var algae7Item = ItemManager.GetItemByName("SilverAlgae");
        var algae7Ingredient = new CostMultiple(new Item_Base[] { algae7Item }, 1);

        // var validItems7 = validItemNames7.Select(name => ItemManager.GetItemByName(name)).ToArray();
        // var validIngredients7 = new CostMultiple(validItems7, 2); SilverAlgae

        var goo = ItemManager.GetItemByName("ClayPlate_SharkDinner");
        goo.settings_recipe.NewCost = new CostMultiple[] { pcs7Ingredient, claybowl7Ingredient, egg7Ingredient, honey7Ingredient, mushroom7Ingredient, chicken7Ingredient, algae7Ingredient };
    }

    /// <param name="pResultItem7">Item resulting from the crafting.</param>
    public static void CreateRecipe7(Item_Base pResultItem7, int pAmount7)
    {
        Traverse.Create(pResultItem7.settings_recipe).Field("craftingCategory").SetValue(CraftingCategory.FoodWater);
        Traverse.Create(pResultItem7.settings_recipe).Field("amountToCraft").SetValue(pAmount7);
    }
    //end SD part 2


    public void OnModifyTank(Network_Player player, float amount, Item_Base itemType = null)
    {
        if (!itemType || !(itemType.name == "Jar_Honey")) return;

        GiveGlass();
    }

    public void OnConsumeItem(Item_Base item)
    {
        if (!(item.name == "Jar_Honey")) return;

        GiveGlass();
    }

    public void GiveGlass()
    {
        _currentUses++;
        if (_currentUses > _num)
        {
            RAPI.GetLocalPlayer().Inventory.AddItem(ItemManager.GetItemByName("Glass").UniqueName, 1);
            _currentUses = 0;
            _num = Random.Range(1, 4);

        }
    }

    public void OnModUnload()
    {

        harmonyInstance.UnpatchAll(HARMONY_ID);
        Debug.Log("Mod RecipesAndMore has been unloaded!");
        Destroy(gameObject);
    }
}
[HarmonyPatch(typeof(Tank)), HarmonyPatch("ModifyTank")]
internal class ModifyTankPatch
{
    private static void Postfix(Tank __instance, Network_Player player, float amount, Item_Base itemType = null)
    {
        if (player == RAPI.GetLocalPlayer())
        {
            ComponentManager<RecipesAndMore>.Value.OnModifyTank(player, amount, itemType);
        }
    }
}

[HarmonyPatch(typeof(PlayerStats)), HarmonyPatch("Consume")]
internal class ConsumePatch
{
    private static void Postfix(PlayerStats __instance, Item_Base edibleItem)
    {
        if (__instance.GetComponent(typeof(Network_Player)) == RAPI.GetLocalPlayer())
        {
            ComponentManager<RecipesAndMore>.Value.OnConsumeItem(edibleItem);
        }
    }
}